#!/bin/bash
#   /usr/local/bin/ripD_eject.sh
#	A DVD rip and eject script.
########################################################################
DEV='/dev/dvd'				# DVD device
MPNT='/cdrom'				# Mount Point
Ddir='/mythtv/video'			# DVD output directory
Bsnd='/usr/share/sounds/init.wav'	# Begin sound file
Esnd='/usr/share/sounds/complete.wav'	# End   sound file
DATE=$(date +%Y%m%d_%H%M)		# current date/time
FONT="-adobe-helvetica-bold-*-*-*-34-*-*-*-*-*-*-*"
OPTS="-f $FONT -s 2 -p bottom -A left -i 50"
#-----------------------------------------------------------------------
[ -r /etc/rip.cfg ] && . /etc/rip.cfg
#-----------------------------------------------------------------------
LOCK=/tmp/.ripLock.$$
[ "$DISPLAY" == "" ] && export DISPLAY=:0
########################################################################
function osd { # $1=text, $2=color, $3=delay
    cmd="osd_cat $OPTS"
    [ -n "$2" ] && cmd="$cmd --color=$2"
    [ -n "$3" ] && cmd="$cmd -d $3"
    killall osd_cat
    echo -e "$1" | $cmd
} >& /dev/null
function osd_loop() {
    FN=$1 ; shift
    TXT=''
    N=0
    while [ -f "$LOCK" ]; do
	[ -d "$FN" ] && SIZE=$(du -sh $FN | awk '{print $1}')
	osd "backup:\n$@\n$SIZE\n$TXT" gray 60
	N=$(($N+1))
	TXT="$N min. elapsed"
    done
}
########################################################################
echo "`date` detected DVD" > /tmp/rip
#date > /tmp/rip
rm -f /tmp/.ripLock.*
#=======================================================================
for dir in $Ddir ; do
    if [ -d $dir -a -w $dir ]; then
	break
    fi
done
#-----------------------------------------------------------------------
if [ ! -d "$dir" ]; then
    echo "no $dir" >> /tmp/rip
    osd "directory\n$dir\nnot found!" red 10 &
    eject ; eject
    exit 0
fi
if [ ! -w "$dir" ]; then
    echo "$dir not writable" >> /tmp/rip
    osd "directory\\n$Cdir\\nnot writable!" red 10 &
    eject ; eject
    exit 0
fi
#-----------------------------------------------------------------------
KnoppMyth-osd "backup to\\n$dir" gray20 5 &
#=======================================================================
osd "detected\nDVD" gray20 3 &
# first make sure DMA is on:
sudo hdparm -d1 $DEV >& /dev/null
# attempt to get the DVD information:
TITLE=$(dvdbackup -i /dev/dvd -I | grep information | awk '{print $8}')
if [ "$TITLE" == "DVD_VIDEO" -o "$TITLE" == "" \
	-o "$TITLE" == " " -o "$TITLE" == "[ ].*" ]; then
    # if not a good title,
    TITLE="dvdbackup_$DATE"
fi
echo $TITLE >> /tmp/rip
{ # for the redir below:
    # Begin:
    touch $LOCK
    osd_loop "$dir/$TITLE" "$TITLE" &
    dvdbackup -i $DEV -I
###    sleep 1 ; play --silent $Bsnd
    vobcopy -i $MPNT -m -t $TITLE -o $dir
    #dvdbackup -M -i $DEV -o $dir -n $TITLE
    #time dd if=$DEV of=$dir/$TITLE.iso bs=2048 
    # Finish:
    rm -f $LOCK
    osd "backup:\n$TITLE\nComplete." gray20 3 &
###    sleep 1 ; play --silent $Esnd
    # Eject the media:
    eject ; eject
} > $dir/$TITLE.log 2>&1
exit 0
########################################################################
# End
